unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  LCLType, LCLIntf;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnStartStop: TButton;
    Memo1: TMemo;
    PanUhr: TPanel;
    procedure BtnStartStopClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    SchleifeStoppen: Boolean;
  public
    procedure Schleife;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  SchleifeStoppen:=true;
end;


procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  SchleifeStoppen:=true;
end;

procedure TForm1.BtnStartStopClick(Sender: TObject);
begin
  if SchleifeStoppen then begin
    BtnStartStop.Caption:='Schleife stoppen';
    Schleife;
  end
  else begin
    BtnStartStop.Caption:='Schleife starten';
    SchleifeStoppen:=true;
  end;
end;

procedure TForm1.Schleife;
begin
  SchleifeStoppen:=false;
  repeat
    PanUhr.Caption:=TimeToStr(now);

    if ((GetKeyState(VK_b) and $8000) <> 0) then Memo1.Lines.Add(IntToStr(GetKeyState(VK_b)));
    if ((GetKeyState(VK_ESCAPE) and $8000) <> 0) then Memo1.Lines.Add(PanUhr.Caption+': Escape gedrückt.');
    if ((GetKeyState(VK_W) and $8000) <> 0) then Memo1.Lines.Add(PanUhr.Caption+': W gedrückt.');
    if ((GetKeyState(VK_A) and $8000) <> 0) then Memo1.Lines.Add(PanUhr.Caption+': A gedrückt.');
    if ((GetKeyState(VK_S) and $8000) <> 0) then Memo1.Lines.Add(PanUhr.Caption+': S gedrückt.');
    if ((GetKeyState(VK_D) and $8000) <> 0) then Memo1.Lines.Add(PanUhr.Caption+': D gedrückt.');


    sleep(10); //um unnötig keine hohe Cpulast zu verursachen (sonst nach einer Weile drehen die Lüfter hoch)
    Application.ProcessMessages;
  until SchleifeStoppen=true;
end;

end.

